<template>
  <div class="paginate-container">
    <Button type="outlined" round size="sm" color="grey" light @click.native="prev">
      <template #icon>
        <Arrow class="arrow arrow--left"/>
      </template>
    </Button>
    <div class="pages">
      <div v-if="distanceFromStart > responsiveOffset" class="page" @click="changePage(1)">
        1
      </div>
      <div v-if="distanceFromStart > responsiveOffset + 1" class="dots">
        ...
      </div>
      <div 
        v-for="(page, i) in displayedPages" 
        :key="i" 
        :class="{page: true, active: page === currentPage}" 
        @click="changePage(page)">
        {{page}}
      </div>
      <div v-if="distanceFromLast > responsiveOffset + 1" class="dots">
        ...
      </div>
      <div v-if="distanceFromLast > responsiveOffset" class="page" @click="changePage(pages)">
        {{this.pages}}
      </div>
    </div>
    <Button type="outlined" round size="sm" color="grey" light @click.native="next">
      <template #icon>
        <Arrow class="arrow arrow--right"/>
      </template>
    </Button>
  </div>
</template>

<script>
import Button from "@/components/base/Button";
import Arrow from "@/assets/svgs/arrow_down.svg";
export default {
  name: "Paginate",
  components: {
    Button,
    Arrow
  },
  data() {
    return {
      currentPage: Number(this.$route.query.page) || 1,
      width: 1200
    }
  },
  props: {
    pages: {
      type: Number,
      default: 5
    },
    offset: {
      type: Number,
      default: 2
    }
  },
  methods: {
    changePage(i) {
      this.currentPage = i;
      this.$router.push(this.$route.path + `?page=${this.currentPage}`);
    },
    next() {
      if (this.currentPage < this.pages) {
        this.changePage(this.currentPage + 1);
      }
    },
    prev() {
      if (this.currentPage > 1) {
        this.changePage(this.currentPage - 1);
      }
    },
    sizeChangeHandler() {
      this.width = window.innerWidth;
    }
  },
  computed: {
    displayedPages() {
      let p = [this.currentPage];
      for (let i = 1; i <= this.responsiveOffset; i++) {
        if (this.currentPage + i <= this.pages) {
          p.push(this.currentPage + i);
        }
      }
      for (let i = 1; i <= this.responsiveOffset; i++) {
        if (this.currentPage - i > 0) {
          p.unshift(this.currentPage - i);
        }
      }
      return p;
    },
    distanceFromLast() {
      return this.pages - this.currentPage; 
    },
    distanceFromStart() {
      return this.currentPage - 1; 
    },
    responsiveOffset() {
      if (this.width < 450) {
        return 0;
      } else if (this.width < 700) {
        return 1;
      }
      return this.offset
    }
  },
  mounted() {
    this.width = window.innerWidth;
    window.addEventListener('resize', this.sizeChangeHandler);
  },
  beforeDestroy() {
    window.removeEventListener('resize', this.sizeChangeHandler);
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.paginate-container
  display flex
  align-items center

.pages
  display flex
  align-items center
  border 1px solid rgba($grey, .2)
  margin 0 $md
  align-self stretch
  @media only screen and (max-width 750px)
    margin 0 $sm

.page
  padding $sm $md
  color $black
  opacity 1
  position relative
  z-index 2
  @media only screen and (max-width 1250px)
    padding $sm
  @media only screen and (max-width 450px)
    padding $sm $xsm
  &::after
    position absolute
    transition all .1s
    content ""
    display block
    z-index -1
    background-color $primary
    border-radius .5rem
    box-shadow 0 0 1.5rem rgba($primary, .4)
    width 110%
    height 120%
    top 50%
    left 50%
    transform translate(-50%, -50%) scale(0)
  &:hover
    background-color rgba(black, .03)
    cursor pointer
  &.active
    &::after
      transform translate(-50%, -50%) scale(1)
    
.arrow
  fill $grey
  &--left
    transform rotate(90deg)
  &--right
    transform rotate(-90deg)

.dots
  top -.4rem
  padding 0 $sm
  letter-spacing .5rem
  position relative
  @media only screen and (max-width 600px)
    letter-spacing .2rem
    padding 0 $xxsm
</style>